# Thanks to Job Vranish (https://spin.atomicobject.com/2016/08/26/makefile-c-projecTARGET_LIBts/)
TARGET_LIB := LIGO_Hardware.a

BUILD_DIR := ./build
SRC_DIRS := ./src

# Find all the C and C++ files we want to compile
# Note the single quotes around the * expressions. The shell will incorrectly expand these otherwise, but we want to send the * directly to the find command.
SRCS := $(shell find $(SRC_DIRS) -name '*.cpp' -or -name '*.c' -or -name '*.s')

# Prepends BUILD_DIR and appends .o to every src file
# As an example, ./your_dir/hello.cpp turns into ./build/./your_dir/hello.cpp.o
OBJS := $(SRCS:%=$(BUILD_DIR)/%.o)

# String substitution (suffix version without %).
# As an example, ./build/hello.cpp.o turns into ./build/hello.cpp.d
DEPS := $(OBJS:.o=.d)

# Every folder in ./src will need to be passed to GCC so that it can find header files
INC_DIRS := ../include ./ #$(shell find $(SRC_DIRS) -type d)
# Add a prefix to INC_DIRS. So moduleA would become -ImoduleA. GCC understands this -I flag
INC_FLAGS := $(addprefix -I,$(INC_DIRS))

# The -MMD and -MP flags together generate Makefiles for us!
# These files will have .d instead of .o as the output.
CPPFLAGS := $(INC_FLAGS) #-MMD -MP

all : $(BUILD_DIR)/ligoDac_example $(BUILD_DIR)/test1 $(BUILD_DIR)/ligoPTC_example

$(BUILD_DIR)/ligoDac_example: $(BUILD_DIR)/ligoDac_example.cpp.o $(BUILD_DIR)/$(TARGET_LIB) 
	$(CXX) -o $@   $<  -L./build -l:$(TARGET_LIB) $(LDFLAGS) 

$(BUILD_DIR)/test1: $(BUILD_DIR)/test1.cpp.o $(BUILD_DIR)/$(TARGET_LIB) 
	$(CXX) -o $@   $<  -L./build -l:$(TARGET_LIB) $(LDFLAGS) 

$(BUILD_DIR)/ligoPTC_example: $(BUILD_DIR)/ligoPTC_example.cpp.o $(BUILD_DIR)/$(TARGET_LIB) 
	$(CXX) -o $@   $<  -L./build -l:$(TARGET_LIB) $(LDFLAGS) 

# The final build step for the library
$(BUILD_DIR)/$(TARGET_LIB): $(OBJS)
	ar rcs $@ $^


# Build step for C++ source
$(BUILD_DIR)/%.cpp.o: %.cpp
	mkdir -p $(dir $@)
	$(CXX) $(CPPFLAGS) $(CXXFLAGS) -c $< -o $@

# Build step for C++ examples/test programs
$(BUILD_DIR)/%.cpp.o: ./examples/%.cpp
	mkdir -p $(dir $@)
	$(CXX) $(CPPFLAGS) $(CXXFLAGS) -c $< -o $@

.PHONY: clean
clean:
	rm -r $(BUILD_DIR)

# Include the .d makefiles. The - at the front suppresses the errors of missing
# Makefiles. Initially, all the .d files will be missing, and we don't want those
# errors to show up.
-include $(DEPS)